#include <htc.h>
#include "user_define.h"

extern  unsigned char   color_1st;
extern  unsigned char   color_2nd;
extern  unsigned char   loop_no;
extern  unsigned char   timer_no;

/*----------EEPROM----------*/
unsigned char E2promRead(unsigned char adr)
{
	EEADR=adr;
	RD=1;
	return(EEDATA);
}

void E2promWrite(unsigned char adr,unsigned char data)
{
	EEADR=adr;
	EEDATA=data;
	
	WREN=1;
	EECON2=0x55;
	EECON2=0xaa;
	
	WR=1;
	while(EEIF==0)
	{
		NOP();
	}
	EEIF=0;
	WREN=0;
}

void	eeprom_write_direct(void)
{
		E2promWrite(0x10,color_1st);
		E2promWrite(0x11,color_2nd);
        E2promWrite(0x12,loop_no);
        E2promWrite(0x13,timer_no);
}

void    eeprom_init(void)
{
 	E2promWrite(0x00,0xaa);
    E2promWrite(0x01,0x55);
    
    color_1st=5;
    color_2nd=6;
    loop_no=1;
    timer_no=5;
    eeprom_write_direct();
}

void	eeprom_check(void)
{
	if((E2promRead(0x00)==0xaa) && (E2promRead(0x01)==0x55)){
		color_1st=E2promRead(0x10);
        color_2nd=E2promRead(0x11);
        loop_no=E2promRead(0x12);
        timer_no=E2promRead(0x13);
	}
	else{
		eeprom_init();
	}
}

