#include <xc.h>
#include <pic16f1827.h>
#include "port_init.h"
#include "user_define.h"
#include "pwm.h"
#include "wait_time.h"


#pragma config BOREN = OFF
#pragma config CPD = OFF 
#pragma config PLLEN = OFF
#pragma config FOSC =INTOSC  
#pragma config MCLRE = ON 
#pragma config WDTE = OFF 
#pragma config CP = OFF 
#pragma config LVP = OFF 
#pragma config PWRTE = ON
#pragma config IESO =OFF
#pragma config FCMEN = OFF
#pragma config BORV = LO
#pragma config WRT = OFF

//unsigned long	hz_no;
unsigned char	pwm1_data;
unsigned char   pwm3_data;
unsigned char   pwm4_data;

//unsigned char	sw1_key;
//unsigned char	sw1_rep;
//unsigned char	sw1_cnt;

unsigned char   time_sec;
unsigned char   time_min;

unsigned int    timer_count;
unsigned char   timer_flg;

unsigned char	sw1p;
unsigned char   color_no;
//unsigned char   kido;
unsigned int    kido_no;
unsigned char   red_no;
unsigned char   green_no;
unsigned char   blue_no;
unsigned char   mode;
unsigned char   color_1st;
unsigned char   color_2nd;
unsigned char   loop_no;
unsigned char   loop;
unsigned char   loop_end;
unsigned char   timer_no;

unsigned int	receive_flg;
unsigned char   rx_data[3];
unsigned char   rx_count;
unsigned int    rx_byte;
unsigned int    loop_count;

unsigned char   pwm_data[101]={
0,3,5,8,10,13,15,18,20,23,25,28,30,33,36,38,41,43,46,48,
51,53,56,58,61,64,66,69,71,74,76,79,81,84,86,89,91,94,97,99, 
102,104,107,109,112,114,117,119,122,124,127,130,132,135,137,140,142,145,147,150, 
152,155,157,160,163,165,168,170,173,175,178,180,183,185,188,191,193,196,198,201, 
203,206,208,211,213,216,218,221,224,226,229,231,234,236,239,241,244,246,249,251,254
};
unsigned char   color_red[16]={100,0,0,100,0,100,100,100,100,50,0,50,0,50,0,50};
unsigned char   color_green[16]={0,100,0,100,100,0,100,50,0,100,100,0,50,50,50,0};
unsigned char   color_blue[16]={0,0,100,0,100,100,100,0,50,0,50,100,100,0,50,50};


// Timer1 interrupt
void interrupt InterTimer( void )
{
    if (TMR1IF == 1) {
        timer_count++;
        if (timer_count >= timer_no) {
            timer_count = 0 ;
            timer_flg = 1;
        }
        TMR1L=TIMER1L_INIT;
        TMR1H=TIMER1H_INIT;
        TMR1IF=0;

     }
    
    if(IOCIF==1){
        if((IOCBF0==1)||(IOCBF2==1)){
            if(IOCBF==1){
                IOCBF0=0;
            }
            if(IOCBF2==1){
                IOCBF2=0;
                loop_count=1;
                if(SET_DATA==0){
                    rx_data[rx_byte]=rx_data[rx_byte] | 0x01;
                }
                rx_count++;
                if(rx_count>=8){
                    rx_count=0;
                    rx_byte++;
                    if(rx_byte>=3){
                        receive_flg=1;
                        rx_count=0;
                        rx_byte=0;
                    }
                }
                else{
                    rx_data[rx_byte]=rx_data[rx_byte] << 1;
                }
            }
            IOCIF=0;
        }

    }
}

// Timer1 init
void    timer1_init(void)
{
    T1CON=0x00;
    TMR1L=TIMER1L_INIT;
    TMR1H=TIMER1H_INIT;
    TMR1IF=0;
    TMR1IE=1;
    PEIE=1;
    GIE=1;
    TMR1ON=1;
}

// RB0,RB2 Int
void    rb0_rb2_int_init(void)
{
    IOCBP=0b00000000;
    IOCBN=0b00000101;
    IOCBF0=0;
    IOCBF2=0;
    IOCIF=0;
    IOCIE=1;
    PEIE=1;
    GIE=1;    
}

// COLOR
void    color_data_set(unsigned char data)
{
	blue_no=color_blue[color_no];         // Blue
    red_no=color_red[color_no];         // Red
    green_no=color_green[color_no];         // Green    
}
void    kido_data_set(unsigned int data)
{
    unsigned int    data1,data3,data4;
    
    data1=(unsigned int)blue_no;
    data1=data1*data/100;
    data1=data1*data1/100;                  //
    blue_no=(unsigned char)data1;
    data3=(unsigned int)red_no;
    data3=data3*data/100;
    data3=data3*data3/100;                  //
    red_no=(unsigned char)data3;    
    data4=(unsigned int)green_no;
    data4=data4*data/100;
    data4=data4*data4/100;                  //
    green_no=(unsigned char)data4;
}
void    pwm_set(void)
{
	set_pwm1(pwm_data[blue_no]);
    set_pwm3(pwm_data[red_no]);
    set_pwm4(pwm_data[green_no]);    
}

// RX
void    rx_data_clear(void)
{
    rx_data[0]=0;
    rx_data[1]=0;
    rx_data[2]=0;
}

// Receive
void    receive_shori(void)
{
    switch(rx_data[0]){
        case 0x43:
            color_1st=(rx_data[1]-0x30)*10+rx_data[2]-0x30;
            eeprom_write_direct();
            break;
        case 0x44:
            color_2nd=(rx_data[1]-0x30)*10+rx_data[2]-0x30;
            eeprom_write_direct();
            break;
        case 0x4c:
            loop_no=rx_data[2]-0x30;
            eeprom_write_direct();
            break;
        case 0x54:
            timer_no=rx_data[2]-0x30;
            eeprom_write_direct();
            break;
    }
}

// MAIN
void	main(void)
{
    OSCCON = 0b01110010;        // 8MHz
    
	port_init();
    
    DCDC_ON=1;NOP();            // DCDC OFF
    
    __delay_ms(5000);    

	sw1p=RB0;NOP();
    if(sw1p==0){
        eeprom_init();
    }
    else{
        eeprom_check();
    }
    color_no=color_1st;             //
    color_data_set(color_no);
    kido_no=0;
    kido_data_set(kido_no);
    loop=loop_no;
    loop_end=0;

    timer_count=0;
    timer_flg=0;
    
    time_sec=0;
    mode=0;
    rx_count=0;
    rx_byte=0;
    rx_data_clear();
    loop_count=0;
    
 	start_pwm();
    pwm_set();
    set_pwm2(pwm_data[100]);     

    rb0_rb2_int_init();
    NOP();
    SLEEP();
    NOP();
    DCDC_ON=0;NOP();        // DCDC ON    
    timer1_init();
  
	while(1){
        
		//sw1p=RB0;NOP();

		//sw1p=RB0;NOP();
        
		/*------------------*/
        
        if(timer_flg==1){
            timer_flg=0;
            switch(mode){
                case 0:
                    kido_no++;
                    if(kido_no>=100){
                        mode=1;
                    }
                    color_data_set(color_no);
                    kido_data_set(kido_no);
                    pwm_set();                    
                    break;
                case 1:
                    kido_no--;
                    if(kido_no==0){
                        mode=2;
                        color_no=color_2nd;
                    }
                    color_data_set(color_no);
                    kido_data_set(kido_no);
                    pwm_set();                                    
                    break;
                case 2:
                    kido_no++;
                    if(kido_no>=100){
                        mode=3;
                    }
                    color_data_set(color_no);
                    kido_data_set(kido_no);
                    pwm_set();                                    
                    break;
                case 3:
                    kido_no--;
                    if(kido_no==0){
                        mode=0;
                        color_no=color_1st;
                        if(loop>0){
                            loop--;
                            if(loop==0){
                                loop_end=1;
                            }
                        }                        
                    }
                    color_data_set(color_no);
                    kido_data_set(kido_no);
                    pwm_set();

                    break;
            }
            

        }
 
        if(loop_end==1){
            loop_end=0;
            loop=loop_no;
            DCDC_ON=1;NOP();            // DCDC OFF
            NOP();
            SLEEP();
            DCDC_ON=0;NOP();        // DCDC ON                
        }
		//*******************
        if(receive_flg==1){
            receive_flg=0;
            receive_shori();
        }
        
        
        //*******************
        if(loop_count>0){
            loop_count++;
            if(loop_count>=1000){
                rx_count=0;
                rx_byte=0;
                rx_data_clear();
                loop_count=0;
            }
        }


	}

}